blob: 3f5ce330a8b7d53979fbb33394541fd0173cfbe7 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Dan Willemsen838dcec2021-09-30 22:40:34 +0000243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000255 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
257
258 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
259 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
260 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200261
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800262 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
263 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
264
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200265 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
266 # to ensure that the corresponding 'emulator' binaries are used.
267 case $(uname -s) in
268 Darwin)
269 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
270 ;;
271 Linux)
272 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
273 ;;
274 *)
275 ANDROID_EMULATOR_PREBUILTS=
276 ;;
277 esac
278 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700279 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200280 export ANDROID_EMULATOR_PREBUILTS
281 fi
282
Jim Tangb3fda302018-12-22 10:24:55 +0800283 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
284 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700285 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
286 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
287 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000288 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800289
Martin Stjernholm6a012262021-11-24 14:56:15 +0000290 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700291 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800292
293 # out with the duplicate old
294 if [ -n $ANDROID_PYTHONPATH ]; then
295 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
296 fi
297 # and in with the new
298 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800299 if [ -n $VENDOR_PYTHONPATH ]; then
300 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
301 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800302 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800303
Colin Crosse97e6932017-06-30 16:01:45 -0700304 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
305 export JAVA_HOME=$ANDROID_JAVA_HOME
306 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
307 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
308 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500309
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800310 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700311 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
312 export OUT=$ANDROID_PRODUCT_OUT
313
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700314 unset ANDROID_HOST_OUT
315 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
316
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900317 unset ANDROID_SOONG_HOST_OUT
318 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
319
Simran Basidd050ed2017-02-13 13:46:48 -0800320 unset ANDROID_HOST_OUT_TESTCASES
321 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
322
323 unset ANDROID_TARGET_OUT_TESTCASES
324 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
325
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800326 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700327 # TODO: fix the path
328 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
329}
330
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000331function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000332{
Jingwen Chen17d56992021-06-10 08:17:54 +0000333 if which bazel &>/dev/null; then
334 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
335 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000336 fi
337
Jingwen Chen17d56992021-06-10 08:17:54 +0000338 local T="$(gettop)"
339 if [ ! "$T" ]; then
340 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
341 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000342 fi
343
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000344 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000345}
346
Matt Alexanderd9c56562020-05-21 10:49:17 +0000347function printconfig()
348{
Christopher Ferris55257d22017-03-23 11:08:58 -0700349 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800350 if [ ! "$T" ]; then
351 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
352 return
353 fi
354 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700355}
356
Matt Alexanderd9c56562020-05-21 10:49:17 +0000357function set_stuff_for_environment()
358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800359 setpaths
360 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700361
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800362 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700363 # With this environment variable new GCC can apply colors to warnings/errors
364 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700365}
366
Matt Alexanderd9c56562020-05-21 10:49:17 +0000367function set_sequence_number()
368{
Colin Cross88737132017-03-21 17:41:03 -0700369 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700370}
371
Makoto Onukida971062018-06-18 10:15:19 -0700372# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
373function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800374 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700375 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800376 *:"$cmd":*)
377 return 1
378 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700379 esac
380 return 0
381}
382
Matt Alexanderd9c56562020-05-21 10:49:17 +0000383function addcompletions()
384{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700385 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700386
Jim Tanga881a252018-06-19 16:34:41 +0800387 # Keep us from trying to run in something that's neither bash nor zsh.
388 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700389 return
390 fi
391
392 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800393 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700394 return
395 fi
396
Jim Tanga881a252018-06-19 16:34:41 +0800397 local completion_files=(
MÃ¥rten Kongstadcb5c73f2022-05-04 14:08:12 +0000398 packages/modules/adb/adb.bash
Jim Tanga881a252018-06-19 16:34:41 +0800399 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800400 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800401 )
Makoto Onukida971062018-06-18 10:15:19 -0700402 # Completion can be disabled selectively to allow users to use non-standard completion.
403 # e.g.
404 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
405 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Usta Shrestha1433fb32022-05-13 14:49:40 -0400406 local T=$(gettop)
Jim Tanga881a252018-06-19 16:34:41 +0800407 for f in ${completion_files[*]}; do
Usta Shrestha1433fb32022-05-13 14:49:40 -0400408 f="$T/$f"
MÃ¥rten Kongstadcb5c73f2022-05-04 14:08:12 +0000409 if [ ! -f "$f" ]; then
410 echo "Warning: completion file $f not found"
411 elif should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700412 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700413 fi
414 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700415
Matt Alexanderd9c56562020-05-21 10:49:17 +0000416 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700417 complete -C "bit --tab" bit
418 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000419 if [ -z "$ZSH_VERSION" ]; then
420 # Doesn't work in zsh.
421 complete -o nospace -F _croot croot
422 fi
Jim Tanga881a252018-06-19 16:34:41 +0800423 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800424
Cole Faust24c36db2021-01-23 02:39:37 +0000425 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100426 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000427 complete -F _complete_android_module_names outmod
428 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100429 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700430}
431
Joe Onorato824608c2022-04-08 11:06:16 -0700432function multitree_lunch_help()
433{
434 echo "usage: lunch PRODUCT-VARIANT" 1>&2
435 echo " Set up android build environment based on a product short name and variant" 1>&2
436 echo 1>&2
437 echo "lunch COMBO_FILE VARIANT" 1>&2
438 echo " Set up android build environment based on a specific lunch combo file" 1>&2
439 echo " and variant." 1>&2
440 echo 1>&2
441 echo "lunch --print [CONFIG]" 1>&2
442 echo " Print the contents of a configuration. If CONFIG is supplied, that config" 1>&2
443 echo " will be flattened and printed. If CONFIG is not supplied, the currently" 1>&2
444 echo " selected config will be printed. Returns 0 on success or nonzero on error." 1>&2
445 echo 1>&2
446 echo "lunch --list" 1>&2
447 echo " List all possible combo files available in the current tree" 1>&2
448 echo 1>&2
449 echo "lunch --help" 1>&2
450 echo "lunch -h" 1>&2
451 echo " Prints this message." 1>&2
452}
453
454function multitree_lunch()
455{
456 local code
457 local results
LaMont Jonesc39e5022022-06-23 19:09:06 +0000458 # Lunch must be run in the topdir, but this way we get a clear error
459 # message, instead of FileNotFound.
460 local T=$(multitree_gettop)
461 if [ -n "$T" ]; then
462 "$T/build/build/make/orchestrator/core/orchestrator.py" "$@"
463 else
464 _multitree_lunch_error
465 return 1
466 fi
Joe Onorato824608c2022-04-08 11:06:16 -0700467 if $(echo "$1" | grep -q '^-') ; then
468 # Calls starting with a -- argument are passed directly and the function
469 # returns with the lunch.py exit code.
LaMont Jonesc39e5022022-06-23 19:09:06 +0000470 "${T}/build/build/make/orchestrator/core/lunch.py" "$@"
Joe Onorato824608c2022-04-08 11:06:16 -0700471 code=$?
472 if [[ $code -eq 2 ]] ; then
473 echo 1>&2
474 multitree_lunch_help
475 return $code
476 elif [[ $code -ne 0 ]] ; then
477 return $code
478 fi
479 else
480 # All other calls go through the --lunch variant of lunch.py
LaMont Jonesc39e5022022-06-23 19:09:06 +0000481 results=($(${T}/build/build/make/orchestrator/core/lunch.py --lunch "$@"))
Joe Onorato824608c2022-04-08 11:06:16 -0700482 code=$?
483 if [[ $code -eq 2 ]] ; then
484 echo 1>&2
485 multitree_lunch_help
486 return $code
487 elif [[ $code -ne 0 ]] ; then
488 return $code
489 fi
490
491 export TARGET_BUILD_COMBO=${results[0]}
492 export TARGET_BUILD_VARIANT=${results[1]}
493 fi
494}
495
Matt Alexanderd9c56562020-05-21 10:49:17 +0000496function choosetype()
497{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700498 echo "Build type choices are:"
499 echo " 1. release"
500 echo " 2. debug"
501 echo
502
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800503 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700504 DEFAULT_NUM=1
505 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700506
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800507 export TARGET_BUILD_TYPE=
508 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700509 while [ -z $TARGET_BUILD_TYPE ]
510 do
511 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000512 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800513 read ANSWER
514 else
515 echo $1
516 ANSWER=$1
517 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700518 case $ANSWER in
519 "")
520 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
521 ;;
522 1)
523 export TARGET_BUILD_TYPE=release
524 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800525 release)
526 export TARGET_BUILD_TYPE=release
527 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700528 2)
529 export TARGET_BUILD_TYPE=debug
530 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800531 debug)
532 export TARGET_BUILD_TYPE=debug
533 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700534 *)
535 echo
536 echo "I didn't understand your response. Please try again."
537 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700538 ;;
539 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000540 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800541 break
542 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700543 done
544
Ying Wang08800fd2016-03-03 20:57:21 -0800545 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700546 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800547 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700548}
549
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800550#
551# This function isn't really right: It chooses a TARGET_PRODUCT
552# based on the list of boards. Usually, that gets you something
553# that kinda works with a generic product, but really, you should
554# pick a product by name.
555#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000556function chooseproduct()
557{
Christopher Ferris55257d22017-03-23 11:08:58 -0700558 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000559 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700560 default_value=$TARGET_PRODUCT
561 else
Ying Wang0a76df52015-06-08 11:57:26 -0700562 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700563 fi
564
Ying Wang08800fd2016-03-03 20:57:21 -0800565 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800566 export TARGET_PRODUCT=
567 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700568 while [ -z "$TARGET_PRODUCT" ]
569 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700570 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000571 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800572 read ANSWER
573 else
574 echo $1
575 ANSWER=$1
576 fi
577
Matt Alexanderd9c56562020-05-21 10:49:17 +0000578 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700579 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800580 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000581 if check_product $ANSWER
582 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800583 export TARGET_PRODUCT=$ANSWER
584 else
585 echo "** Not a valid product: $ANSWER"
586 fi
587 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000588 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800589 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700590 fi
591 done
592
Ying Wang08800fd2016-03-03 20:57:21 -0800593 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700594 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800595 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700596}
597
Matt Alexanderd9c56562020-05-21 10:49:17 +0000598function choosevariant()
599{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800600 echo "Variant choices are:"
601 local index=1
602 local v
603 for v in ${VARIANT_CHOICES[@]}
604 do
605 # The product name is the name of the directory containing
606 # the makefile we found, above.
607 echo " $index. $v"
608 index=$(($index+1))
609 done
610
611 local default_value=eng
612 local ANSWER
613
614 export TARGET_BUILD_VARIANT=
615 while [ -z "$TARGET_BUILD_VARIANT" ]
616 do
617 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000618 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800619 read ANSWER
620 else
621 echo $1
622 ANSWER=$1
623 fi
624
Matt Alexanderd9c56562020-05-21 10:49:17 +0000625 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800626 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000627 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
628 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200629 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800630 fi
631 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000632 if check_variant $ANSWER
633 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800634 export TARGET_BUILD_VARIANT=$ANSWER
635 else
636 echo "** Not a valid variant: $ANSWER"
637 fi
638 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000639 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800640 break
641 fi
642 done
643}
644
Matt Alexanderd9c56562020-05-21 10:49:17 +0000645function choosecombo()
646{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700647 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700648
649 echo
650 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700651 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700652
653 echo
654 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700655 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800656
657 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800658 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700659 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800660 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800661 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700662}
663
Matt Alexanderd9c56562020-05-21 10:49:17 +0000664function add_lunch_combo()
665{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800666 if [ -n "$ZSH_VERSION" ]; then
667 echo -n "${funcfiletrace[1]}: "
668 else
669 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
670 fi
671 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800672}
673
Matt Alexanderd9c56562020-05-21 10:49:17 +0000674function print_lunch_menu()
675{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700676 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100677 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700678 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100679 local ret=$?
680
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700681 echo
682 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700683 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100684
Matt Alexanderd9c56562020-05-21 10:49:17 +0000685 if [ $ret -ne 0 ]
686 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100687 echo "Warning: Cannot display lunch menu."
688 echo
689 echo "Note: You can invoke lunch with an explicit target:"
690 echo
691 echo " usage: lunch [target]" >&2
692 echo
693 return
694 fi
695
Will Burr40401202022-02-07 12:12:01 +0000696 echo "Lunch menu .. Here are the common combinations:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800697
698 local i=1
699 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700700 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800701 do
702 echo " $i. $choice"
703 i=$(($i+1))
704 done
705
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700706 echo
707}
708
Matt Alexanderd9c56562020-05-21 10:49:17 +0000709function lunch()
710{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800711 local answer
712
Steven Moreland92793dc2020-02-25 18:30:18 -0800713 if [[ $# -gt 1 ]]; then
714 echo "usage: lunch [target]" >&2
715 return 1
716 fi
717
Will Burr40401202022-02-07 12:12:01 +0000718 local used_lunch_menu=0
719
Steven Moreland92793dc2020-02-25 18:30:18 -0800720 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800721 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700722 else
723 print_lunch_menu
Will Burr40401202022-02-07 12:12:01 +0000724 echo "Which would you like? [aosp_arm-eng]"
725 echo -n "Pick from common choices above (e.g. 13) or specify your own (e.g. aosp_barbet-eng): "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800726 read answer
Will Burr40401202022-02-07 12:12:01 +0000727 used_lunch_menu=1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700728 fi
729
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800730 local selection=
731
Matt Alexanderd9c56562020-05-21 10:49:17 +0000732 if [ -z "$answer" ]
733 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700734 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000735 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
736 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800737 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000738 if [ $answer -le ${#choices[@]} ]
739 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800740 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000741 if [ -n "$ZSH_VERSION" ]
742 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800743 selection=${choices[$(($answer))]}
744 else
745 selection=${choices[$(($answer-1))]}
746 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800747 fi
Colin Cross88737132017-03-21 17:41:03 -0700748 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800749 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700750 fi
751
Joe Onoratoda12daf2010-06-09 18:18:31 -0700752 export TARGET_BUILD_APPS=
753
Colin Cross88737132017-03-21 17:41:03 -0700754 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700755 product=${selection%%-*} # Trim everything after first dash
756 variant_and_version=${selection#*-} # Trim everything up to first dash
757 if [ "$variant_and_version" != "$selection" ]; then
758 variant=${variant_and_version%%-*}
759 if [ "$variant" != "$variant_and_version" ]; then
760 version=${variant_and_version#*-}
761 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700762 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800763
Matt Alexanderd9c56562020-05-21 10:49:17 +0000764 if [ -z "$product" ]
765 then
Ying Wang08800fd2016-03-03 20:57:21 -0800766 echo
Colin Cross88737132017-03-21 17:41:03 -0700767 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700768 return 1
769 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800770
Colin Cross88737132017-03-21 17:41:03 -0700771 TARGET_PRODUCT=$product \
772 TARGET_BUILD_VARIANT=$variant \
773 TARGET_PLATFORM_VERSION=$version \
774 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000775 if [ $? -ne 0 ]
776 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100777 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
778 then
779 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
780 fi
Colin Cross88737132017-03-21 17:41:03 -0700781 return 1
782 fi
Colin Cross88737132017-03-21 17:41:03 -0700783 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
784 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700785 if [ -n "$version" ]; then
786 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
787 else
788 unset TARGET_PLATFORM_VERSION
789 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700790 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700791
Will Burr40401202022-02-07 12:12:01 +0000792 if [ $used_lunch_menu -eq 1 ]; then
793 echo
794 echo "Hint: next time you can simply run 'lunch $selection'"
795 fi
796
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700797 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800798
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700799 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700800 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800801 destroy_build_var_cache
Kousik Kumar41dacd12021-05-11 18:38:38 -0400802
803 if [[ -n "${CHECK_MU_CONFIG:-}" ]]; then
804 check_mu_config
805 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700806}
807
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700808unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700809# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000810function _lunch()
811{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700812 local cur prev opts
813 COMPREPLY=()
814 cur="${COMP_WORDS[COMP_CWORD]}"
815 prev="${COMP_WORDS[COMP_CWORD-1]}"
816
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700817 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800818 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700819 fi
820
821 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700822 return 0
823}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700824
Joe Onoratoda12daf2010-06-09 18:18:31 -0700825# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700826# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000827function tapas()
828{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700829 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800830 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700831 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700832 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Colin Cross7f49a672022-01-27 18:15:53 -0800833 local keys="$(echo $* | xargs -n 1 echo | \grep -E '^(devkeys)$' | xargs)"
834 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi|devkeys)$' | xargs)"
835
Joe Onoratoda12daf2010-06-09 18:18:31 -0700836
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700837 if [ "$showHelp" != "" ]; then
838 $(gettop)/build/make/tapasHelp.sh
839 return
840 fi
841
Ying Wang67f02922012-08-22 10:25:20 -0700842 if [ $(echo $arch | wc -w) -gt 1 ]; then
843 echo "tapas: Error: Multiple build archs supplied: $arch"
844 return
845 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700846 if [ $(echo $variant | wc -w) -gt 1 ]; then
847 echo "tapas: Error: Multiple build variants supplied: $variant"
848 return
849 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700850 if [ $(echo $density | wc -w) -gt 1 ]; then
851 echo "tapas: Error: Multiple densities supplied: $density"
852 return
853 fi
Colin Cross7f49a672022-01-27 18:15:53 -0800854 if [ $(echo $keys | wc -w) -gt 1 ]; then
855 echo "tapas: Error: Multiple keys supplied: $keys"
856 return
857 fi
Ying Wang67f02922012-08-22 10:25:20 -0700858
Ying Wang0a76df52015-06-08 11:57:26 -0700859 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700860 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000861 x86) product=aosp_x86;;
862 arm64) product=aosp_arm64;;
863 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700864 esac
Colin Cross7f49a672022-01-27 18:15:53 -0800865 if [ -n "$keys" ]; then
866 product=${product/aosp_/aosp_${keys}_}
867 fi;
868
Joe Onoratoda12daf2010-06-09 18:18:31 -0700869 if [ -z "$variant" ]; then
870 variant=eng
871 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700872 if [ -z "$apps" ]; then
873 apps=all
874 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600875 if [ -z "$density" ]; then
876 density=alldpi
877 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700878
Ying Wang67f02922012-08-22 10:25:20 -0700879 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700880 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700881 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700882 export TARGET_BUILD_TYPE=release
883 export TARGET_BUILD_APPS=$apps
884
Ying Wang08800fd2016-03-03 20:57:21 -0800885 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700886 set_stuff_for_environment
887 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800888 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700889}
890
Martin Stjernholmf692c752021-04-12 00:01:10 +0100891# Configures the build to build unbundled Android modules (APEXes).
892# Run banchan with one or more module names (from apex{} modules).
893function banchan()
894{
895 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100896 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100897 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100898 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100899
900 if [ "$showHelp" != "" ]; then
901 $(gettop)/build/make/banchanHelp.sh
902 return
903 fi
904
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100905 if [ -z "$product" ]; then
Anton Hansson0328e322022-05-24 15:47:40 +0000906 product=arm64
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100907 elif [ $(echo $product | wc -w) -gt 1 ]; then
908 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100909 return
910 fi
911 if [ $(echo $variant | wc -w) -gt 1 ]; then
912 echo "banchan: Error: Multiple build variants supplied: $variant"
913 return
914 fi
915 if [ -z "$apps" ]; then
916 echo "banchan: Error: No modules supplied"
917 return
918 fi
919
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100920 case $product in
921 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100922 x86) product=module_x86;;
923 arm64) product=module_arm64;;
924 x86_64) product=module_x86_64;;
925 esac
926 if [ -z "$variant" ]; then
927 variant=eng
928 fi
929
930 export TARGET_PRODUCT=$product
931 export TARGET_BUILD_VARIANT=$variant
932 export TARGET_BUILD_DENSITY=alldpi
933 export TARGET_BUILD_TYPE=release
934
935 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
936 # case is different and it may diverge in the future.
937 export TARGET_BUILD_APPS=$apps
938
939 build_build_var_cache
940 set_stuff_for_environment
941 printconfig
942 destroy_build_var_cache
943}
944
Matt Alexanderd9c56562020-05-21 10:49:17 +0000945function gettop
946{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700947 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000948 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700949 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000950 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700951 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000952 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800953 # The following circumlocution (repeated below as well) ensures
954 # that we record the true directory name and not one that is
955 # faked up with symlink names.
956 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700957 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800958 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700959 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000960 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800961 \cd ..
synergyb112a402013-07-05 19:47:47 -0700962 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700963 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000964 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700965 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000966 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700967 fi
968 fi
969 fi
970}
971
Joe Onorato7cf6f972022-05-11 21:39:57 -0700972# TODO: Merge into gettop as part of launching multitree
973function multitree_gettop
974{
975 local TOPFILE=build/build/make/core/envsetup.mk
976 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
977 # The following circumlocution ensures we remove symlinks from TOP.
978 (cd "$TOP"; PWD= /bin/pwd)
979 else
980 if [ -f $TOPFILE ] ; then
981 # The following circumlocution (repeated below as well) ensures
982 # that we record the true directory name and not one that is
983 # faked up with symlink names.
984 PWD= /bin/pwd
985 else
986 local HERE=$PWD
987 local T=
988 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
989 \cd ..
990 T=`PWD= /bin/pwd -P`
991 done
992 \cd "$HERE"
993 if [ -f "$T/$TOPFILE" ]; then
994 echo "$T"
995 fi
996 fi
997 fi
998}
999
Matt Alexanderd9c56562020-05-21 10:49:17 +00001000function croot()
1001{
Christopher Ferris55257d22017-03-23 11:08:58 -07001002 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001003 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -07001004 if [ "$1" ]; then
1005 \cd $(gettop)/$1
1006 else
1007 \cd $(gettop)
1008 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001009 else
1010 echo "Couldn't locate the top of the tree. Try setting TOP."
1011 fi
1012}
1013
Matt Alexanderd9c56562020-05-21 10:49:17 +00001014function _croot()
1015{
Anton Hanssonece9c482019-02-04 18:15:39 +00001016 local T=$(gettop)
1017 if [ "$T" ]; then
1018 local cur="${COMP_WORDS[COMP_CWORD]}"
1019 k=0
1020 for c in $(compgen -d ${T}/${cur}); do
1021 COMPREPLY[k++]=${c#${T}/}/
1022 done
1023 fi
1024}
1025
Matt Alexanderd9c56562020-05-21 10:49:17 +00001026function cproj()
1027{
Colin Cross6cdc5d22017-10-20 11:37:33 -07001028 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001029 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -07001030 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001031 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
1032 T=$PWD
1033 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -08001034 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001035 return
1036 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001037 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001038 done
Ying Wang9cd17642012-12-13 10:52:07 -08001039 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -07001040 echo "can't find Android.mk"
1041}
1042
Daniel Sandler47e0a882013-07-30 13:23:52 -04001043# simplified version of ps; output in the form
1044# <pid> <procname>
1045function qpid() {
1046 local prepend=''
1047 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +00001048 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -04001049 prepend=' '
1050 append='$'
1051 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +00001052 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -08001053 echo "usage: qpid [[--exact] <process name|pid>"
1054 return 255
1055 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001056
1057 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001058 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -08001059 qpid | \grep "$prepend$EXE$append"
1060 else
1061 adb shell ps \
1062 | tr -d '\r' \
1063 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
1064 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001065}
1066
Steven Moreland74114f12020-09-10 01:23:32 +00001067# syswrite - disable verity, reboot if needed, and remount image
1068#
1069# Easy way to make system.img/etc writable
1070function syswrite() {
1071 adb wait-for-device && adb root || return 1
Frederick Maylee59a8792022-08-22 22:40:23 +00001072 if [[ $(adb disable-verity | grep -i "reboot") ]]; then
Steven Moreland74114f12020-09-10 01:23:32 +00001073 echo "rebooting"
1074 adb reboot && adb wait-for-device && adb root || return 1
1075 fi
1076 adb wait-for-device && adb remount || return 1
1077}
1078
Iliyan Malcheve675cfb2014-11-03 17:04:47 -08001079# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001080# that has the core-file-size limit set correctly
1081#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001082# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001083# if its core-file-size limit is not set already.
1084# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
1085
Matt Alexanderd9c56562020-05-21 10:49:17 +00001086function coredump_setup()
1087{
1088 echo "Getting root...";
1089 adb root;
1090 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001091
Matt Alexanderd9c56562020-05-21 10:49:17 +00001092 echo "Remounting root partition read-write...";
1093 adb shell mount -w -o remount -t rootfs rootfs;
1094 sleep 1;
1095 adb wait-for-device;
1096 adb shell mkdir -p /cores;
1097 adb shell mount -t tmpfs tmpfs /cores;
1098 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001099
Matt Alexanderd9c56562020-05-21 10:49:17 +00001100 echo "Granting SELinux permission to dump in /cores...";
1101 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001102
Matt Alexanderd9c56562020-05-21 10:49:17 +00001103 echo "Set core pattern.";
1104 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001105
Ying Wang08800fd2016-03-03 20:57:21 -08001106 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001107}
1108
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001109# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001110# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001111#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001112# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001113# dump to actually be generated.
1114
Matt Alexanderd9c56562020-05-21 10:49:17 +00001115function coredump_enable()
1116{
1117 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001118 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001119 printf "Expecting a PID!\n";
1120 return;
1121 fi;
1122 echo "Setting core limit for $PID to infinite...";
xi yuaddf4832022-05-26 12:41:21 +00001123 adb shell /system/bin/ulimit -P $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001124}
1125
1126# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001127# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001128#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001129# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001130# enabled globally.
1131
Matt Alexanderd9c56562020-05-21 10:49:17 +00001132function core()
1133{
1134 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001135
Ying Wang08800fd2016-03-03 20:57:21 -08001136 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001137 printf "Expecting a PID!\n";
1138 return;
1139 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001140
Matt Alexanderd9c56562020-05-21 10:49:17 +00001141 local CORENAME=core.$PID;
1142 local COREPATH=/cores/$CORENAME;
1143 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001144
Matt Alexanderd9c56562020-05-21 10:49:17 +00001145 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001146
Matt Alexanderd9c56562020-05-21 10:49:17 +00001147 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001148 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001149 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1150 adb shell kill -$SIG $PID;
1151 sleep 1;
1152 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001153
Matt Alexanderd9c56562020-05-21 10:49:17 +00001154 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1155 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001156}
1157
Christopher Tate744ee802009-11-12 15:33:08 -08001158# systemstack - dump the current stack trace of all threads in the system process
1159# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001160function systemstack()
1161{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001162 stacks system_server
1163}
1164
Michael Wrightaeed7212014-06-19 19:58:12 -07001165# Read the ELF header from /proc/$PID/exe to determine if the process is
1166# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001167function is64bit()
1168{
Ben Chengfba67bf2014-02-25 10:27:07 -08001169 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001170 if [ "$PID" ] ; then
1171 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001172 echo "64"
1173 else
1174 echo ""
1175 fi
1176 else
1177 echo ""
1178 fi
1179}
1180
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001181case `uname -s` in
1182 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001183 function sgrep()
1184 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001185 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001186 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001187 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001188
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001189 ;;
1190 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001191 function sgrep()
1192 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001193 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001194 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001195 }
1196 ;;
1197esac
1198
Matt Alexanderd9c56562020-05-21 10:49:17 +00001199function gettargetarch
1200{
Raghu Gandham8da43102012-07-25 19:57:22 -07001201 get_build_var TARGET_ARCH
1202}
1203
Matt Alexanderd9c56562020-05-21 10:49:17 +00001204function ggrep()
1205{
Mike Frysinger5e479732015-09-22 18:13:48 -04001206 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1207 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001208}
1209
Matt Alexanderd9c56562020-05-21 10:49:17 +00001210function gogrep()
1211{
Orion Hodson831472d2019-10-25 11:35:15 +01001212 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1213 -exec grep --color -n "$@" {} +
1214}
1215
Matt Alexanderd9c56562020-05-21 10:49:17 +00001216function jgrep()
1217{
Mike Frysinger5e479732015-09-22 18:13:48 -04001218 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1219 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001220}
1221
Alistair Delva176e5342021-02-22 13:31:26 -08001222function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001223{
1224 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1225 -exec grep --color -n "$@" {} +
1226}
1227
Taesu Leeea0cecd2020-10-28 11:05:18 +09001228function ktgrep()
1229{
1230 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1231 -exec grep --color -n "$@" {} +
1232}
1233
Matt Alexanderd9c56562020-05-21 10:49:17 +00001234function cgrep()
1235{
Mike Frysinger5e479732015-09-22 18:13:48 -04001236 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1237 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001238}
1239
Matt Alexanderd9c56562020-05-21 10:49:17 +00001240function resgrep()
1241{
Christopher Ferris55257d22017-03-23 11:08:58 -07001242 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001243 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1244 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1245 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001246}
1247
Matt Alexanderd9c56562020-05-21 10:49:17 +00001248function mangrep()
1249{
Mike Frysinger5e479732015-09-22 18:13:48 -04001250 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1251 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001252}
1253
Matt Alexanderd9c56562020-05-21 10:49:17 +00001254function owngrep()
1255{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001256 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1257 -exec grep --color -n "$@" {} +
1258}
1259
Matt Alexanderd9c56562020-05-21 10:49:17 +00001260function sepgrep()
1261{
Mike Frysinger5e479732015-09-22 18:13:48 -04001262 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1263 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001264}
1265
Matt Alexanderd9c56562020-05-21 10:49:17 +00001266function rcgrep()
1267{
Mike Frysinger5e479732015-09-22 18:13:48 -04001268 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1269 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001270}
1271
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001272case `uname -s` in
1273 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001274 function mgrep()
1275 {
Orion Hodson831472d2019-10-25 11:35:15 +01001276 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001277 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001278 }
1279
Matt Alexanderd9c56562020-05-21 10:49:17 +00001280 function treegrep()
1281 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001282 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001283 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001284 }
1285
1286 ;;
1287 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001288 function mgrep()
1289 {
Orion Hodson831472d2019-10-25 11:35:15 +01001290 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001291 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001292 }
1293
Matt Alexanderd9c56562020-05-21 10:49:17 +00001294 function treegrep()
1295 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001296 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001297 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001298 }
1299
1300 ;;
1301esac
1302
Matt Alexanderd9c56562020-05-21 10:49:17 +00001303function getprebuilt
1304{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001305 get_abs_build_var ANDROID_PREBUILTS
1306}
1307
Matt Alexanderd9c56562020-05-21 10:49:17 +00001308function tracedmdump()
1309{
Christopher Ferris55257d22017-03-23 11:08:58 -07001310 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001311 if [ ! "$T" ]; then
1312 echo "Couldn't locate the top of the tree. Try setting TOP."
1313 return
1314 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001315 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001316 local arch=$(gettargetarch)
1317 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001318
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001319 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001320 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001321 echo "usage: tracedmdump tracename"
1322 return
1323 fi
1324
Matt Alexanderd9c56562020-05-21 10:49:17 +00001325 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001326 echo "Error: cannot find kernel: '$KERNEL'"
1327 return
1328 fi
1329
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001330 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001331 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001332 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1333 fi
1334
1335 echo "post-processing traces..."
1336 rm -f $TRACE/qtrace.dexlist
1337 post_trace $TRACE
1338 if [ $? -ne 0 ]; then
1339 echo "***"
1340 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1341 echo "***"
1342 return
1343 fi
1344 echo "generating dexlist output..."
1345 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1346 echo "generating dmtrace data..."
1347 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1348 echo "generating html file..."
1349 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1350 echo "done, see $TRACE/dmtrace.html for details"
1351 echo "or run:"
1352 echo " traceview $TRACE/dmtrace"
1353}
1354
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001355# communicate with a running device or emulator, set up necessary state,
1356# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001357function runhat()
1358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001359 # process standard adb options
1360 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001361 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001362 adbTarget=$1
1363 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001364 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001365 adbTarget="$1 $2"
1366 shift 2
1367 fi
1368 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001369 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001370
1371 # runhat options
1372 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001373
Matt Alexanderd9c56562020-05-21 10:49:17 +00001374 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001375 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001376 return
1377 fi
1378
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001379 # confirm hat is available
1380 if [ -z $(which hat) ]; then
1381 echo "hat is not available in this configuration."
1382 return
1383 fi
1384
Andy McFaddenb6289852010-07-12 08:00:19 -07001385 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001386 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001387 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001388 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001389 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001390 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001391 echo -n "> "
1392 read
1393
The Android Open Source Project88b60792009-03-03 19:28:42 -08001394 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001395
The Android Open Source Project88b60792009-03-03 19:28:42 -08001396 echo "Retrieving file $devFile..."
1397 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001398
The Android Open Source Project88b60792009-03-03 19:28:42 -08001399 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001400
The Android Open Source Project88b60792009-03-03 19:28:42 -08001401 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001402 echo "View the output by pointing your browser at http://localhost:7000/"
1403 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001404 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001405}
1406
Matt Alexanderd9c56562020-05-21 10:49:17 +00001407function getbugreports()
1408{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001409 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001410
1411 if [ ! "$reports" ]; then
1412 echo "Could not locate any bugreports."
1413 return
1414 fi
1415
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001416 local report
1417 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001418 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001419 echo "/sdcard/bugreports/${report}"
1420 adb pull /sdcard/bugreports/${report} ${report}
1421 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001422 done
1423}
1424
Matt Alexanderd9c56562020-05-21 10:49:17 +00001425function getsdcardpath()
1426{
Victoria Lease1b296b42012-08-21 15:44:06 -07001427 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1428}
1429
Matt Alexanderd9c56562020-05-21 10:49:17 +00001430function getscreenshotpath()
1431{
Victoria Lease1b296b42012-08-21 15:44:06 -07001432 echo "$(getsdcardpath)/Pictures/Screenshots"
1433}
1434
Matt Alexanderd9c56562020-05-21 10:49:17 +00001435function getlastscreenshot()
1436{
Victoria Lease1b296b42012-08-21 15:44:06 -07001437 local screenshot_path=$(getscreenshotpath)
1438 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001439 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001440 echo "No screenshots found."
1441 return
1442 fi
1443 echo "${screenshot}"
1444 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1445}
1446
Matt Alexanderd9c56562020-05-21 10:49:17 +00001447function startviewserver()
1448{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001449 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001450 if [ $# -gt 0 ]; then
1451 port=$1
1452 fi
1453 adb shell service call window 1 i32 $port
1454}
1455
Matt Alexanderd9c56562020-05-21 10:49:17 +00001456function stopviewserver()
1457{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001458 adb shell service call window 2
1459}
1460
Matt Alexanderd9c56562020-05-21 10:49:17 +00001461function isviewserverstarted()
1462{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001463 adb shell service call window 3
1464}
1465
Matt Alexanderd9c56562020-05-21 10:49:17 +00001466function key_home()
1467{
Romain Guyb84049a2010-10-04 16:56:11 -07001468 adb shell input keyevent 3
1469}
1470
Matt Alexanderd9c56562020-05-21 10:49:17 +00001471function key_back()
1472{
Romain Guyb84049a2010-10-04 16:56:11 -07001473 adb shell input keyevent 4
1474}
1475
Matt Alexanderd9c56562020-05-21 10:49:17 +00001476function key_menu()
1477{
Romain Guyb84049a2010-10-04 16:56:11 -07001478 adb shell input keyevent 82
1479}
1480
Matt Alexanderd9c56562020-05-21 10:49:17 +00001481function smoketest()
1482{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001483 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1484 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1485 return
1486 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001487 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001488 if [ ! "$T" ]; then
1489 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1490 return
1491 fi
1492
Ying Wang9cd17642012-12-13 10:52:07 -08001493 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001494 adb uninstall com.android.smoketest > /dev/null &&
1495 adb uninstall com.android.smoketest.tests > /dev/null &&
1496 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1497 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1498 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1499}
1500
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001501# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001502function runtest()
1503{
Christopher Ferris55257d22017-03-23 11:08:58 -07001504 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001505 if [ ! "$T" ]; then
1506 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1507 return
1508 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001509 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001510}
1511
The Android Open Source Project88b60792009-03-03 19:28:42 -08001512function godir () {
1513 if [[ -z "$1" ]]; then
1514 echo "Usage: godir <regex>"
1515 return
1516 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001517 local T=$(gettop)
1518 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001519 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001520 mkdir -p $OUT_DIR
1521 FILELIST=$OUT_DIR/filelist
1522 else
1523 FILELIST=$T/filelist
1524 fi
1525 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001526 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001527 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001528 echo " Done"
1529 echo ""
1530 fi
1531 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001532 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001533 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001534 echo "Not found"
1535 return
1536 fi
1537 local pathname
1538 local choice
1539 if [[ ${#lines[@]} > 1 ]]; then
1540 while [[ -z "$pathname" ]]; do
1541 local index=1
1542 local line
1543 for line in ${lines[@]}; do
1544 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001545 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001546 done
1547 echo
1548 echo -n "Select one: "
1549 unset choice
1550 read choice
1551 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1552 echo "Invalid choice"
1553 continue
1554 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001555 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001556 done
1557 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001558 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001559 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001560 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001561}
1562
Steven Moreland62054a42018-12-06 10:11:40 -08001563# Update module-info.json in out.
1564function refreshmod() {
1565 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1566 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1567 return 1
1568 fi
1569
1570 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1571
1572 # for the output of the next command
1573 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1574
1575 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001576 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001577 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1578}
1579
Cole Faust3e192382021-10-25 13:29:15 -07001580# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001581function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001582 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001583 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1584 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1585 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001586 return 1
1587 fi
1588
1589 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001590 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001591 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001592 fi
1593 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001594 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001595}
1596
1597# List all modules for the current device, as cached in module-info.json. If any build change is
1598# made and it should be reflected in the output, you should run 'refreshmod' first.
1599function allmod() {
1600 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001601
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001602 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001603}
1604
Joe Onorato2c1aa472021-02-25 16:42:39 -08001605# Get the path of a specific module in the android tree, as cached in module-info.json.
1606# If any build change is made, and it should be reflected in the output, you should run
1607# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001608function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001609 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001610 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001611 return 1
1612 fi
1613
Cole Faust24c36db2021-01-23 02:39:37 +00001614 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001615
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001616 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001617module = '$1'
1618module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1619if module not in module_info:
1620 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001621print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001622
1623 if [ -z "$relpath" ]; then
1624 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1625 return 1
1626 else
Rett Berg78d1c932019-01-24 14:34:23 -08001627 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001628 fi
1629}
1630
Joe Onorato2c1aa472021-02-25 16:42:39 -08001631# Get the path of a specific module in the android tree, as cached in module-info.json.
1632# If any build change is made, and it should be reflected in the output, you should run
1633# 'refreshmod' first. Note: This is the inverse of pathmod.
1634function dirmods() {
1635 if [[ $# -ne 1 ]]; then
1636 echo "usage: dirmods <path>" >&2
1637 return 1
1638 fi
1639
1640 verifymodinfo || return 1
1641
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001642 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001643dir = '$1'
1644while dir.endswith('/'):
1645 dir = dir[:-1]
1646prefix = dir + '/'
1647module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1648results = set()
1649for m in module_info.values():
1650 for path in m.get(u'path', []):
1651 if path == dir or path.startswith(prefix):
1652 name = m.get(u'module_name')
1653 if name:
1654 results.add(name)
1655for name in sorted(results):
1656 print(name)
1657"
1658}
1659
1660
Rett Berg78d1c932019-01-24 14:34:23 -08001661# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1662# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1663function gomod() {
1664 if [[ $# -ne 1 ]]; then
1665 echo "usage: gomod <module>" >&2
1666 return 1
1667 fi
1668
1669 local path="$(pathmod $@)"
1670 if [ -z "$path" ]; then
1671 return 1
1672 fi
1673 cd $path
1674}
1675
Cole Faust24c36db2021-01-23 02:39:37 +00001676# Gets the list of a module's installed outputs, as cached in module-info.json.
1677# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1678function outmod() {
1679 if [[ $# -ne 1 ]]; then
1680 echo "usage: outmod <module>" >&2
1681 return 1
1682 fi
1683
1684 verifymodinfo || return 1
1685
1686 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001687 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001688module = '$1'
1689module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1690if module not in module_info:
1691 exit(1)
1692for output in module_info[module]['installed']:
1693 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1694
1695 if [ $? -ne 0 ]; then
1696 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1697 return 1
1698 elif [ ! -z "$relpath" ]; then
1699 echo "$relpath"
1700 fi
1701}
1702
1703# adb install a module's apk, as cached in module-info.json. If any build change
1704# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1705# Usage: installmod [adb install arguments] <module>
1706# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1707function installmod() {
1708 if [[ $# -eq 0 ]]; then
1709 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001710 echo "" >&2
1711 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1712 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1713 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001714 return 1
1715 fi
1716
1717 local _path
1718 _path=$(outmod ${@:$#:1})
1719 if [ $? -ne 0 ]; then
1720 return 1
1721 fi
1722
1723 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1724 if [ -z "$_path" ]; then
1725 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1726 return 1
1727 fi
Cole Faust3e192382021-10-25 13:29:15 -07001728 local serial_device=""
1729 if [[ "$1" == "-s" ]]; then
1730 if [[ $# -le 2 ]]; then
1731 echo "-s requires an argument" >&2
1732 return 1
1733 fi
1734 serial_device="-s $2"
1735 shift 2
1736 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001737 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001738 echo adb $serial_device install ${@:1:$length} $_path
1739 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001740}
1741
dimitry73b84812018-12-11 18:06:00 +01001742function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001743 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001744 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001745}
1746
Alex Rayf0d08eb2013-03-08 15:15:06 -08001747# Print colored exit condition
1748function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001749 "$@"
1750 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001751 if [ $retval -ne 0 ]
1752 then
Jacky Cao89483b82015-05-15 22:12:53 +08001753 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001754 else
Jacky Cao89483b82015-05-15 22:12:53 +08001755 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001756 fi
1757 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001758}
1759
Matt Alexanderd9c56562020-05-21 10:49:17 +00001760function get_make_command()
1761{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001762 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1763 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001764 # Always use the real make if -C is passed in
1765 for arg in "$@"; do
1766 if [[ $arg == -C* ]]; then
1767 echo command make
1768 return
1769 fi
1770 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001771 echo build/soong/soong_ui.bash --make-mode
1772 else
1773 echo command make
1774 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001775}
1776
Matt Alexanderd9c56562020-05-21 10:49:17 +00001777function _wrap_build()
1778{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001779 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1780 "$@"
1781 return $?
1782 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001783 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001784 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001785 local ret=$?
1786 local end_time=$(date +"%s")
1787 local tdiff=$(($end_time-$start_time))
1788 local hours=$(($tdiff / 3600 ))
1789 local mins=$((($tdiff % 3600) / 60))
1790 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001791 local ncolors=$(tput colors 2>/dev/null)
1792 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001793 color_failed=$'\E'"[0;31m"
1794 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001795 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001796 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001797 else
1798 color_failed=""
1799 color_success=""
1800 color_reset=""
1801 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001802
1803 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1804 echo
1805 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1806 fi
1807
Ed Heylcc6be0a2014-06-18 14:55:58 -07001808 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001809 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001810 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001811 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001812 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001813 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001814 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001815 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001816 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001817 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001818 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001819 printf "(%s seconds)" $secs
1820 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001821 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001822 echo
1823 return $ret
1824}
1825
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001826function _trigger_build()
1827(
1828 local -r bc="$1"; shift
LaMont Jonesc39e5022022-06-23 19:09:06 +00001829 local T=$(gettop)
1830 if [ -n "$T" ]; then
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001831 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1832 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001833 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1834 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001835 fi
1836)
1837
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001838# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001839function b()
1840(
Sam Delmericoe4c74c52022-08-30 10:17:38 -04001841 # Look for the --run-soong-tests flag and skip passing --skip-soong-tests to Soong if present
1842 local bazel_args=""
1843 local skip_tests="--skip-soong-tests"
1844 for i in $@; do
1845 if [[ $i != "--run-soong-tests" ]]; then
1846 bazel_args+="$i "
1847 else
1848 skip_tests=""
1849 fi
1850 done
Jingwen Chend728ee12021-05-18 06:02:53 +00001851 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Jingwen Chene7b2c972022-08-30 08:54:06 +00001852 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001853 # Then, run Bazel using the synthetic workspace as the --package_path.
Sam Delmericoe4c74c52022-08-30 10:17:38 -04001854 if [[ -z "$bazel_args" ]]; then
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001855 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001856 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001857 else
1858 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Cole Fausta68f5162022-08-18 17:33:51 -07001859 # Add the --config=bp2build after the first argument that doesn't start with a dash. That should be the bazel
1860 # command. (build, test, run, ect) If the --config was added at the end, it wouldn't work with commands like:
1861 # b run //foo -- --args-for-foo
Sam Delmericoe31d7de2022-08-29 17:39:44 -04001862 local config_set=0
1863 local bazel_args_with_config=""
Sam Delmericoe4c74c52022-08-30 10:17:38 -04001864 for arg in $bazel_args; do
Sam Delmericoe31d7de2022-08-29 17:39:44 -04001865 if [[ $arg == "--" && $config_set -ne 1 ]]; # if we find --, insert config argument here
Cole Fausta68f5162022-08-18 17:33:51 -07001866 then
Sam Delmericoe31d7de2022-08-29 17:39:44 -04001867 bazel_args_with_config+="--config=bp2build -- "
1868 config_set=1
1869 else
1870 bazel_args_with_config+="$arg "
Cole Fausta68f5162022-08-18 17:33:51 -07001871 fi
1872 done
Sam Delmericoe31d7de2022-08-29 17:39:44 -04001873 if [[ $config_set -ne 1 ]]; then
1874 bazel_args_with_config+="--config=bp2build "
1875 fi
1876 eval "bazel $bazel_args_with_config"
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001877 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001878)
1879
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001880function m()
1881(
1882 _trigger_build "all-modules" "$@"
1883)
1884
1885function mm()
1886(
1887 _trigger_build "modules-in-a-dir-no-deps" "$@"
1888)
1889
1890function mmm()
1891(
1892 _trigger_build "modules-in-dirs-no-deps" "$@"
1893)
1894
1895function mma()
1896(
1897 _trigger_build "modules-in-a-dir" "$@"
1898)
1899
1900function mmma()
1901(
1902 _trigger_build "modules-in-dirs" "$@"
1903)
1904
Matt Alexanderd9c56562020-05-21 10:49:17 +00001905function make()
1906{
Dan Willemsene9842242017-07-28 13:00:13 -07001907 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001908}
1909
Joe Onorato7cf6f972022-05-11 21:39:57 -07001910function _multitree_lunch_error()
1911{
1912 >&2 echo "Couldn't locate the top of the tree. Please run \'source build/envsetup.sh\' and multitree_lunch from the root of your workspace."
1913}
1914
1915function multitree_build()
1916{
LaMont Jonesc39e5022022-06-23 19:09:06 +00001917 local T=$(multitree_gettop)
1918 if [ -n "$T" ]; then
1919 "$T/build/build/make/orchestrator/core/orchestrator.py" "$@"
Joe Onorato7cf6f972022-05-11 21:39:57 -07001920 else
1921 _multitree_lunch_error
1922 return 1
1923 fi
1924}
1925
Matt Alexanderd9c56562020-05-21 10:49:17 +00001926function provision()
1927{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001928 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1929 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1930 return 1
1931 fi
1932 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1933 echo "There is no provisioning script for the device." >&2
1934 return 1
1935 fi
1936
1937 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001938 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001939 shift 1
1940 else
1941 echo "This action will reflash your device."
1942 echo ""
1943 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1944 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001945 echo -n "Are you sure you want to do this (yes/no)? "
1946 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001947 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001948 echo "Not taking any action. Exiting." >&2
1949 return 1
1950 fi
1951 fi
1952 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1953}
1954
Jim Tanga881a252018-06-19 16:34:41 +08001955# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001956function enable_zsh_completion() {
1957 # Don't override user's options if bash-style completion is already enabled.
1958 if ! declare -f complete >/dev/null; then
1959 autoload -U compinit && compinit
1960 autoload -U bashcompinit && bashcompinit
1961 fi
Jim Tanga881a252018-06-19 16:34:41 +08001962}
1963
1964function validate_current_shell() {
1965 local current_sh="$(ps -o command -p $$)"
1966 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001967 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001968 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001969 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001970 *zsh*)
1971 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001972 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001973 *)
Jim Tanga881a252018-06-19 16:34:41 +08001974 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001975 ;;
1976 esac
Jim Tanga881a252018-06-19 16:34:41 +08001977}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001978
1979# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001980# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1981# load those.
1982#
1983# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001984function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001985 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001986 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001987 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001988 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001989 if [ -n "$allowed" ]; then
1990 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1991 echo " $allowed"
1992 echo " $f"
1993 return
1994 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001995 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001996 done
1997
1998 allowed_files=
1999 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08002000 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00002001 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08002002 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08002003
2004 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00002005 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08002006 else
2007 echo "ignoring $f, not in $allowed"
2008 fi
Jim Tanga881a252018-06-19 16:34:41 +08002009 done
2010 done
2011}
Kenny Root52aa81c2011-07-15 11:07:06 -07002012
Dan Albertbab814f2020-08-26 15:34:53 -07002013function showcommands() {
2014 local T=$(gettop)
2015 if [[ -z "$TARGET_PRODUCT" ]]; then
2016 >&2 echo "TARGET_PRODUCT not set. Run lunch."
2017 return
2018 fi
2019 case $(uname -s) in
2020 Darwin)
2021 PREBUILT_NAME=darwin-x86
2022 ;;
2023 Linux)
2024 PREBUILT_NAME=linux-x86
2025 ;;
2026 *)
2027 >&2 echo Unknown host $(uname -s)
2028 return
2029 ;;
2030 esac
2031 if [[ -z "$OUT_DIR" ]]; then
2032 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
2033 OUT_DIR=out
2034 else
2035 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
2036 fi
2037 fi
2038 if [[ "$1" == "--regenerate" ]]; then
2039 shift 1
2040 NINJA_ARGS="-t commands $@" m
2041 else
2042 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
2043 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
2044 -t commands "$@")
2045 fi
2046}
2047
Cole Faust45844ab2022-08-30 13:59:07 -07002048function avbtool() {
2049 if [[ ! -f "$ANDROID_SOONG_HOST_OUT"/bin/avbtool ]]; then
2050 m avbtool
2051 fi
2052 "$ANDROID_SOONG_HOST_OUT"/bin/avbtool $@
2053}
2054
Jim Tanga881a252018-06-19 16:34:41 +08002055validate_current_shell
2056source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07002057addcompletions